VERSION 5.00
Begin VB.Form frmFileFind 
   Caption         =   "File Finder"
   ClientHeight    =   5220
   ClientLeft      =   60
   ClientTop       =   345
   ClientWidth     =   6435
   Icon            =   "FILE Find.frx":0000
   LinkTopic       =   "Form1"
   ScaleHeight     =   5220
   ScaleWidth      =   6435
   StartUpPosition =   3  'Windows Default
   Begin VB.PictureBox picBanner 
      Align           =   1  'Align Top
      Appearance      =   0  'Flat
      BackColor       =   &H80000005&
      BorderStyle     =   0  'None
      ForeColor       =   &H80000008&
      Height          =   615
      Left            =   0
      MouseIcon       =   "FILE Find.frx":0ABA
      MousePointer    =   99  'Custom
      Picture         =   "FILE Find.frx":0EFC
      ScaleHeight     =   615
      ScaleWidth      =   6435
      TabIndex        =   10
      Top             =   0
      Width           =   6435
   End
   Begin VB.ListBox lstFiles 
      Height          =   2460
      IntegralHeight  =   0   'False
      Left            =   120
      MultiSelect     =   2  'Extended
      TabIndex        =   8
      Top             =   2400
      Width           =   6255
   End
   Begin VB.Frame fraInfo 
      Caption         =   "File Info"
      Height          =   1575
      Left            =   120
      TabIndex        =   0
      Top             =   720
      Width           =   6255
      Begin VB.CheckBox chkSubDirs 
         Caption         =   "Include Subdirectories"
         Height          =   255
         Left            =   1320
         TabIndex        =   7
         Top             =   1200
         Width           =   2055
      End
      Begin VB.CommandButton cmdStop 
         Cancel          =   -1  'True
         Caption         =   "Stop Search"
         Enabled         =   0   'False
         Height          =   375
         Left            =   4680
         TabIndex        =   6
         Top             =   720
         Width           =   1455
      End
      Begin VB.CommandButton cmdFind 
         Caption         =   "Find"
         Default         =   -1  'True
         Height          =   375
         Left            =   4680
         TabIndex        =   5
         Top             =   240
         Width           =   1455
      End
      Begin VB.TextBox txtPattern 
         Height          =   375
         Left            =   1320
         TabIndex        =   3
         Text            =   "*.*"
         Top             =   720
         Width           =   3015
      End
      Begin VB.TextBox txtDir 
         Height          =   375
         Left            =   1320
         TabIndex        =   1
         Top             =   240
         Width           =   3015
      End
      Begin VB.Image imgFind 
         Height          =   480
         Left            =   120
         Picture         =   "FILE Find.frx":1F25
         Top             =   1080
         Width           =   480
      End
      Begin VB.Label lblPattern 
         Caption         =   "Pattern:"
         Height          =   255
         Left            =   120
         TabIndex        =   4
         Top             =   840
         Width           =   1215
      End
      Begin VB.Label lblDir 
         Caption         =   "Directory:"
         Height          =   255
         Left            =   120
         TabIndex        =   2
         Top             =   360
         Width           =   1215
      End
   End
   Begin VB.Label lblStatus 
      AutoSize        =   -1  'True
      Caption         =   "(Searching in: ...)"
      Height          =   195
      Left            =   120
      TabIndex        =   9
      Top             =   4920
      Width           =   1200
   End
End
Attribute VB_Name = "frmFileFind"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit
'==================================================================
'
' File Finder and Lowercaser Window
'
' 29 September 2001
' 09 March 2002 - Update for Windows 2000/XP
'
' You're free in using this software, as long as the
' orignal copyright/author information remains intact.
' In other words, respecting the person(s) who made it
' possible for you to view/learn something of this software.
'
' Copyright  2001 - Diederik van der Boor
' http://www.codingdomain.com
'
'==================================================================


' File Finder
Private WithEvents FileFinder As FileFinder
Attribute FileFinder.VB_VarHelpID = -1


' Do we pause for the label update / user cancel?
Private StartTime As Date
Private EndTime As Date
Private PrevTime As Date


'------------------------------------------------------------------
' Form

Private Sub Form_Load()
  Set FileFinder = New FileFinder
  lblStatus.Caption = ""
End Sub

Private Sub Form_Unload(Cancel As Integer)
  FileFinder.Cancel
End Sub

Private Sub Form_Resize()
  If Me.ScaleWidth > 6000 Then
    fraInfo.Width = Me.ScaleWidth - 2 * fraInfo.Left - 100
    lstFiles.Width = Me.ScaleWidth - 2 * lstFiles.Left - 100
    If Me.ScaleHeight > lstFiles.Top Then
      lstFiles.Height = Me.ScaleHeight - lstFiles.Top - lblStatus.Height - 80
    End If
    
    cmdFind.Left = fraInfo.Width - cmdFind.Width - 400
    cmdStop.Left = cmdFind.Left
    
    lblStatus.Width = Me.ScaleWidth - 2 * lblStatus.Left - 100
    lblStatus.Top = Me.ScaleHeight - lblStatus.Height - 40
    
    txtDir.Width = cmdFind.Left - txtDir.Left - 400
    txtPattern.Width = cmdStop.Left - txtPattern.Left - 400
  End If
End Sub




'------------------------------------------------------------------
' Command Buttons

Private Sub cmdFind_Click()
  On Error Resume Next
    Call FileFinder.Find(txtDir.Text, txtPattern.Text, chkSubDirs.Value)
    If Err.Number Then MsgBox Err.Description, vbExclamation + vbMsgBoxSetForeground, "API call: " & Err.Source
  On Error GoTo 0
End Sub

Private Sub cmdStop_Click()
  Call FileFinder.Cancel
End Sub


'------------------------------------------------------------------
' Text box

Private Sub txtDir_KeyPress(KeyAscii As Integer)
  If KeyAscii = vbKeyReturn Then
    Call cmdFind_Click
  End If
End Sub


'------------------------------------------------------------------
' Events Raised by file finder

Private Sub FileFinder_DirChange(DirName As String)
  EndTime = Time - StartTime
  lblStatus.Caption = "Time Past: " & Hour(EndTime) & "h " & Minute(EndTime) & "m " & Second(EndTime) & "s." & _
                      " Searching in " & DirName & "..."
  If Time() <> PrevTime Then DoEvents
  PrevTime = Time()
End Sub

Private Sub FileFinder_Found(FileName As String, FileAttr As FileAttributes)
  lstFiles.AddItem FileName
End Sub

Private Sub FileFinder_SearchInitialize()
  lstFiles.Clear
  lblStatus.Caption = ""
  StartTime = Time
  cmdStop.Enabled = True
  DoEvents
End Sub

Private Sub FileFinder_SearchTerminate(Canceled As Boolean)
  Dim I As Long
  DoEvents
  If Not Canceled Then
    EndTime = Time - StartTime
    lblStatus.Caption = "Time Past: " & Hour(EndTime) & "h " & Minute(EndTime) & "m " & Second(EndTime) & "s. " & _
                        lstFiles.ListCount & " files found."
  Else
    cmdStop.Enabled = False
    EndTime = Time - StartTime
    lblStatus.Caption = "Time Past: " & Hour(EndTime) & "h " & Minute(EndTime) & "m " & Second(EndTime) & "s. " & _
                        "Search Canceled after " & lstFiles.ListCount & " matches!"
  End If
  DoEvents
  lstFiles.ListIndex = -1
  cmdStop.Enabled = False
End Sub




'------------------------------------------------------------------
' Banner

Private Sub picBanner_Click()
  MsgBox "Copyright  2001 - Diederik van der Boor" & vbCrLf _
       & vbCrLf _
       & "Anyone is allowed to use this software freely, as long as" & vbCrLf _
       & "the the copright information in the source code remains intact." & vbCrLf _
       & vbCrLf _
       & "http://www.codingdomain.com"
End Sub

